package it.unitn.disi.prog2.museoFerroviario;

import it.unitn.disi.prog2.museoFerroviario.rotabili.*;

import java.util.LinkedList;

public class ListOfRotabili extends LinkedList<Rotabile> {
    ListOfRotabili(boolean create){
        if (create) {
            this.add(new LocomotivaVapore("880",1916, "1-C","locotender"));
            this.add(new LocomotivaVapore("940",1922, "1-D-1","locotender"));
            this.add(new LocomotivaVapore("740",1911, "1-D","separato"));
            this.add(new LocomotoreElettrico("E.432",1928, "1-D-1","trifase"));
            this.add(new LocomotoreElettrico("E.626",1931,"BoBoBo","continua"));
            this.add(new LocomotoreElettrico("E.636",1940,"BoBoBo","continua"));
            this.add(new VagonePasseggeri("Tipo 1921",1921 ,42));
            this.add(new VagonePasseggeri("Tipo Lz",1926,79));
            this.add(new VagonePasseggeri("Tipo 1928R",1928,14));
            this.add(new CarroMerci("FDIz 149",1931,95));
            this.add(new CarroMerci("Fma",1925,24));
            this.add(new CarroMerci("F 1942", 1942,43));
        }
    }
    ListOfRotabili createSublist(char c){
        ListOfRotabili sublist=new ListOfRotabili(false); //create an empty list
        for (Rotabile r:this){
            if (check(r,c)) sublist.add(r);
        }
        return sublist;
    }
    boolean check(Object o,char c) {
        switch (c) {
            case 'R':
                return o instanceof Rotabile;
            case 'M':
                return o instanceof Motrice;
            case 'V':
                return o instanceof LocomotivaVapore;
            case 'E':
                return o instanceof LocomotoreElettrico;
            case 'T':
                return o instanceof RotabileTrainato;
            case 'P':
                return o instanceof VagonePasseggeri;
            case 'C':
                return o instanceof CarroMerci;
        }
        return false;
    }
    public static void main(String a[]){
        char c='C';
        ListOfRotabili all=new ListOfRotabili(true);
        ListOfRotabili subset=all.createSublist(c);
        System.out.println(subset);
    }
    public String toString() {
        StringBuffer sb=new StringBuffer("---------------\n");
        for (Rotabile r:this) {
            sb.append(r);
            sb.append("\n");
        }
        sb.append("---------------");
        return sb.toString();
    }
}
