package it.unitn.disi.prog2.museoFerroviario;

import it.unitn.disi.prog2.museoFerroviario.rotabili.*;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class ViewStage extends Stage {
    ListOfRotabili lista;
    StackPane root;
    public Button orderByYear;
    public Button orderByName;
    char shownType;
    RotabileComparatorByName cbm=new RotabileComparatorByName();
    RotabileComparatorByYear cby=new RotabileComparatorByYear();

    ViewStage() {
        root = new StackPane();
        Scene scene = new Scene(root, 350, 400);
        scene.setOnKeyTyped(new EventHandler<KeyEvent>() {
            @Override
            public void handle(KeyEvent keyEvent) {
                String c=keyEvent.getCharacter();
                if (c.equals("D")||c.equals("d")) {
                    orderByYear.fireEvent(new ActionEvent());
                } else if (c.equals("N")||c.equals("n")) {
                    orderByName.fireEvent(new ActionEvent());
                }
            }
        });
        setTitle("View");
        setScene(scene);
        setX(250);
        setY(10);
    }

    void setLista(ListOfRotabili lista) {
        this.lista = lista;
        showLista();
    }

    public void setShownType(char id) {
        shownType = id;
    }

    public void showLista() {
        GridPane gp = new GridPane();
        gp.setHgap(10);
        gp.setVgap(10);
        int riga = 0;
        int colonna=0;
        for (Rotabile r : lista) {
            riga++;
            colonna=0;
            String modello = r.modello;
            int anno = r.anno;
            gp.add(new Label(modello), colonna++, riga);
            gp.add(new Label("" + anno), colonna++, riga);
            switch (shownType) {
                case 'M': //motrice
                    gp.add(new Label(((Motrice) r).rodiggio), colonna++, riga);
                    break;
                case 'V': //vapore
                    gp.add(new Label(((Motrice) r).rodiggio), colonna++, riga);
                    gp.add(new Label(((LocomotivaVapore) r).tender), colonna++, riga);
                    break;
                case 'E': //elettrico
                    gp.add(new Label(((Motrice) r).rodiggio), colonna++, riga);
                    gp.add(new Label(((LocomotoreElettrico) r).corrente), colonna++, riga);
                    break;
                case 'P':
                    gp.add(new Label(((VagonePasseggeri) r).posti + ""), colonna++, riga);
                    break;
                case 'C':
                    gp.add(new Label(((CarroMerci) r).capacita + ""), colonna++, riga);
                    break;
            }
        }
        ViewStage vs=this;
        orderByName=new Button("order by name");
        orderByName.setOnAction(new EventHandler< ActionEvent>(){
            @Override
            public void handle(ActionEvent actionEvent) {
                lista.sort(cbm);
                System.out.println(lista);
                vs.showLista();               }
        });
        gp.add(orderByName,0, ++riga);
        //
        orderByYear=new Button("order by year");
        orderByYear.setOnAction(new EventHandler< ActionEvent>(){
            @Override
            public void handle(ActionEvent actionEvent) {
                lista.sort(cby);
                System.out.println(lista);
                vs.showLista();               }
        });
        gp.add(orderByYear,1, riga);
        root.getChildren().clear();
        root.getChildren().add(gp);
        this.show();
    }
}
